//
//  character.h
//  Lily
//
//  Created by KMY on 2015/05/06.
//  Copyright (c) 2015年 KMY. All rights reserved.
//

#ifndef __Lily__character__
#define __Lily__character__

#include <stdio.h>
typedef unsigned int lchar;

class Character
{
public:
	static bool isHalf(lchar c);
	static bool isFull(lchar c);
	static int fullCount();					// 全角文字のバイト数を返す
	static bool isAscii(lchar c);
	static bool isFull_utf8(lchar c);
	static int fullCount_utf8();
	static void strcpy(const char* from, char* to, int len=0);
	static void strcpyn(const char* from, char** to, int len=0);
	static int strlen(const char* str);
	static int strlen(const lchar* str);

	static void lstrcpy(const lchar* from, lchar* to, int len=0);
	static void lstrcpyn(const lchar* from, lchar** to, int len=0);
	static int lstrlen(const char* string);		// char*をlchar*に変換した時必要になる長さ
											//		(NULL除外のため配列生成時は大きさに1を足す必要）
	static int lstrlen(const lchar* string);		// lchar*の文字列長
	
	static void toLchar(const char* from, lchar* to, int lcharLen, int charLen = 0);
	static void toLcharn(const char* from, lchar** to, int charLen = 0);
	static void toChar(const lchar* from, char* to, int charlen, int lcharLen = 0);
	static void toCharn(const lchar* from, char** to, int lcharLen = 0);
	
	static int toLchar(const char* from, lchar* to);		// 1文字のみ、半角／全角で処理を分ける
	static int toChar(lchar from, char* to);		//　（NULL文字は関係ない）半角1、全角はバイト数を返
	
	static bool equal(const char* str1, const char* str2);
	static bool equal(const char* str1, const lchar* str2);
	static bool equal(const lchar* str1, const char* str2);
	static bool equal(const lchar* str1, const lchar* str2);
	static bool equal(char c1, char c2);
	static bool equal(const char* c1, lchar c2);	// utf8なら、半角は1バイト、全角は3バイト参照
	static bool equal(lchar c1, const char* c2);	//　　　　　　（NULL文字は関係ない）
	static bool equal(lchar c1, lchar c2);
};

#endif /* defined(__Lily__character__) */
